/**********************************************************************
 * Copyright (C) 20014-2015 by Vidisolve (Pty) Ltd.                   *
 * All Rights Reserved.                                               *
 *                                                                    *
 *  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY    *
 *   KIND, either express or implied.                                 *
 *                                                                    *
 *  Contributors:                                                     *
 *                                                                    *
 **********************************************************************/
/*------------------------------------------------------------------------
    File        : customProcedure.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Tue Jun 09 20:00:43 CAT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

BLOCK-LEVEL ON ERROR UNDO, THROW.

/* ***************************  Main Block  *************************** */
DEFINE VARIABLE lSuccess   AS LOGICAL   NO-UNDO.
DEFINE VARIABLE cRoles     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cRoleNames AS CHARACTER NO-UNDO.

DEFINE VARIABLE hCP AS HANDLE NO-UNDO.

DEFINE VARIABLE iChoice   AS INTEGER NO-UNDO.

DEFINE VARIABLE cUser     AS CHARACTER NO-UNDO.
DEFINE VARIABLE cPassword AS CHARACTER NO-UNDO.



CURRENT-WINDOW:WIDTH = 140.

REPEAT WITH FRAME f SIDE-LABELS WIDTH 132 THREE-D 
    ON ERROR UNDO, RETRY:
        
    CLEAR FRAME f NO-PAUSE.
    DISPLAY
        "Select login Method" SKIP
        "===================" SKIP
        "1. Use the CustomSSO system against an arbitrarty user registry." SKIP
        "2. OE Based login using the default blank domain and the _oeusertable system." SKIP
        "3. OE Based login using the PUG Domain and our OECustom system." SKIP
        "4. Login with my OS user." SKIP(1)
        .
    UPDATE
        iChoice FORMAT "9" LABEL "Selection" SKIP.

    CASE iChoice:
        /* The following line logs the user in using the CustomSSO domain,
           validating against an arbitrary user registry. */
        WHEN 1
        THEN RUN SecurityDomains/CustomSSO/pLogin.p ("simon",
                                                     ENCODE("1"),
                                                     OUTPUT lSuccess,
                                                     OUTPUT cRoles,
                                                     OUTPUT cRoleNames).

        /* The following line will use OE based authentication and authenticate
           the user against the _User table, using the default blank domain and
           the _oeuser authentication system           */
        WHEN 2
        THEN RUN SecurityDomains/OE/pLogin.p ("SimonDB",
                                              "DB").

        /* The following line will use OE based authentication and authenticate
           the user against our own registry, using the PUG domain and our
           own authentication system           */
        WHEN 3
        THEN RUN SecurityDomains/OE/pLogin.p ("simon@PUG", ENCODE("1")).

        /* The following use the MyWindows domain, but ideally we want to 
           configure the actual windows domain, as in OS-GETENV("USERDOMAIN"),
           to authenticate the user with a domain user and password. 
           Of course we can also authenticate the user on a totally different
           windows domain.
        */
        WHEN 4
        THEN DO:
            cUser = SUBSTITUTE("&1@&2",OS-GETENV("USERNAME"),
                                       "MyWindows" /*OS-GETENV("USERDOMAIN")*/ ).
                                       
            UPDATE 
                cUser     FORMAT "x(40)"       LABEL "Windows User Name" COLON 21 SKIP
                cPassword FORMAT "x(40)" BLANK LABEL "Windows password"  COLON 21 SKIP
                .
            RUN SecurityDomains/OE/pLogin.p (cUser, cPassword).
        END.
        OTHERWISE NEXT.
    END CASE.

    hCP = SECURITY-POLICY:GET-CLIENT ().

    DISPLAY SKIP(1)
        hCP:QUALIFIED-USER-ID          LABEL "hCP:QUALIFIED-USER-ID"            COLON 39 FORMAT "X(60)" SKIP
        hCP:USER-ID                    LABEL "hCP:USER-ID"                      COLON 39 FORMAT "X(60)" SKIP
        hCP:DOMAIN-NAME                LABEL "hCP:DOMAIN-NAME"                  COLON 39 FORMAT "X(60)" SKIP
        hCP:LOGIN-EXPIRATION-TIMESTAMP LABEL "hCP:LOGIN-EXPIRATION-TIMESTAMP"   COLON 39                SKIP
        hCP:ROLES                      LABEL "hCP:ROLES"                        COLON 39 FORMAT "X(60)" SKIP
        hCP:GET-PROPERTY ("RoleNames") LABEL "hCP:GET-PROPERTY (~"RoleNames~")" COLON 39 FORMAT "X(60)" SKIP
        hCP:STATE-DETAIL               LABEL "hCP:STATE-DETAIL"                 COLON 39 FORMAT "X(60)" SKIP
        .
        
    
END.
/*
hCP = GET-DB-CLIENT ("Sports2000").

MESSAGE
        hCP:QUALIFIED-USER-ID           SKIP
        hCP:USER-ID                     SKIP
        hCP:LOGIN-EXPIRATION-TIMESTAMP  SKIP
        hCP:ROLES                       SKIP
        hCP:GET-PROPERTY ("RoleNames")  SKIP
        hCP:STATE-DETAIL                SKIP
        hCP
    VIEW-AS ALERT-BOX TITLE "Sports2000 Detail".


hCP = GET-DB-CLIENT ("security").

MESSAGE
        hCP:QUALIFIED-USER-ID           SKIP
        hCP:USER-ID                     SKIP
        hCP:LOGIN-EXPIRATION-TIMESTAMP  SKIP
        hCP:ROLES                       SKIP
        hCP:GET-PROPERTY ("RoleNames")  SKIP
        hCP:STATE-DETAIL                SKIP

        hCP
    VIEW-AS ALERT-BOX TITLE "Security DB Detail".
*/
