/**********************************************************************
 * Copyright (C) 20014-2015 by Vidisolve (Pty) Ltd.                   *
 * All Rights Reserved.                                               *
 *                                                                    *
 *  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY    *
 *   KIND, either express or implied.                                 *
 *                                                                    *
 *  Contributors:                                                     *
 *                                                                    *
 **********************************************************************/
/*------------------------------------------------------------------------
    File        : pAuthentication.p
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Tue Jun 09 19:26:21 CAT 2015
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

BLOCK-LEVEL ON ERROR UNDO, THROW.

/* ***************************  Main Block  *************************** */

DEFINE INPUT  PARAMETER pLoginID   AS CHARACTER NO-UNDO.
DEFINE INPUT  PARAMETER pPasswd    AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER pSuccess   AS LOGICAL   NO-UNDO.
DEFINE OUTPUT PARAMETER pRoles     AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER pRolesDesc AS CHARACTER NO-UNDO.

DEFINE VARIABLE hCP AS HANDLE NO-UNDO.

/* Alternative 1 */
SECURITY-POLICY:LOAD-DOMAINS("security").

/* Alternative 2 */
/*
SECURITY-POLICY:REGISTER-DOMAIN("AppDomain","DomainSecretKey").
SECURITY-POLICY:LOCK-REGISTRATION ().
  */

IF pLoginID = ?
THEN RETURN.

CREATE CLIENT-PRINCIPAL hCP.

FIND secUser NO-LOCK
    WHERE secUser.loginID = pLoginID
      AND secUser.passwd  = pPasswd
    NO-ERROR.

/* Alternative 1 */
ASSIGN
    hCP:USER-ID     = pLoginId
    hCP:DOMAIN-NAME = "AppDomain"
    hCP:SESSION-ID  = GUID
    hCP:LOGIN-EXPIRATION-TIMESTAMP = DATETIME-TZ(TODAY + 1)
    .
/* Alternative 2 */
/*
ASSIGN
    hCP:QUALIFIED-USER-ID = SUBSTITUTE("&1@AppDomain",pLoginID)
    hCP:SESSION-ID        = GUID
    hCP:LOGIN-EXPIRATION-TIMESTAMP = DATETIME-TZ(TODAY + 1)
    .
*/
/* Alternative 3 */
/*
hCP:INITIALIZE(SUBSTITUTE("&1@AppDomain",pLoginID), /* qualified-user-id     */
               GUID,                                /* session-id (Optional) */
               DATETIME-TZ(TODAY + 1),              /* expiration            */
               "").                                 /* primary-passphrase    */
*/

IF AVAILABLE secUser
THEN DO:
    FOR EACH userRole OF secUser, FIRST role OF userRole:
        pRoles = pRoles + "," + role.roleKey.
        pRolesDesc = pRolesDesc + "," + role.Description.
    END.
    ASSIGN
        pSuccess = TRUE
        pRoles     = SUBSTRING(pRoles,2)
        pRolesDesc = SUBSTRING(pRolesDesc,2)
        hCP:ROLES  = pRoles
        .
    hCP:SET-PROPERTY("RoleNames",pRolesDesc).

    hCP:SEAL("DomainSecretKey").
    IF SESSION:REMOTE
    THEN SESSION:CURRENT-RESPONSE-INFO:SetClientPrincipal(hCP).
    ELSE SECURITY-POLICY:SET-CLIENT (hCP) .

END.
ELSE hCP:AUTHENTICATION-FAILED ("I do not know this user.").

RETURN.
